#-------------------------------------------------------------------------------
# Name:        output
#-------------------------------------------------------------------------------
#!/usr/bin/env python



#-------------------------------------------------------------------------------
# imports we need
import sys
import os
#-------------------------------------------------------------------------------



#-------------------------------------------------------------------------------
# include top level directory (needed to import from helper below)
#curpath = os.path.dirname(os.path.realpath(__file__))
#parpath = os.path.normpath(os.path.join(curpath, "../.."))
#sys.path.append(parpath+"/core")

# import the helper classes
from TWLCHelper import *
#-------------------------------------------------------------------------------

















#---------------------------------------------------------------------------
class TOutputFormatter(object):

    def __init__(self):
        # create the TWLCHelper helper
        self.helper = TWLCHelper()
        # defaults?
        self.outputformatcode = "UNKNOWN"


    def __del__(self):
        pass


    def DoParseCommandline(self,comlineargs):
        # set usage
        self.helper.set_usage("sample usage: %prog [options] arg")
        #
        # commandline options
        self.helper.get_parser().add_option("", "--infile", dest="infile", help="input file (full path)")
        self.helper.get_parser().add_option("", "--outfile", dest="outfile", help="output file (full path), or defaults to stdout")
        # derived specific
        self.ParseDerivedCommandlineArgs()
        # ok parse some args from commandline
        self.helper.ParseCommandlineParameters(comlineargs)
        # open filein and fileout files (or stdio)
        self.helper.OpenIO()


    def ParseDerivedCommandlineArgs(self):
        # parse any derived object specific commandline options
        pass

    def PostParseDerivedCommandlineArgs(self):
        # now we can look at any parsed commandline options
        pass


    def RunWithCommandlineOptions(self,comlineargs):
        # get input and output files

        self.DoParseCommandline(comlineargs)
        self.PostParseDerivedCommandlineArgs()

        infile=self.helper.get_filein()
        outfile=self.helper.get_fileout()

        # ok now we are going to load all results into a big list
        resultlist = self.helper.LoadAndParseAllResults(infile)

        # sort items in resultlist
        resultlist = self.DoSort_ResultLists(resultlist)

        # output format line
        self.DoOutput_FormatLine(outfile)

        # ok now we have the full result list, we want to format output
        self.DoOutput_FromResultList(outfile,resultlist)

        # success
        return 0


    def DoSort_ResultLists(self,resultlist):
        resultlistout = []
        for resultgroup in resultlist:
            resultgroup = self.DoSort_Group(resultgroup)
            resultlistout.append(resultgroup)
        return resultlistout

    def DoSort_Group(self,resultgroup):
        resultgroupout = sorted(resultgroup, key=lambda k: int(k['score']), reverse=True)
        return resultgroupout



    def DoOutput_FormatLine(self,outfile):
        # we write out a comment line with output format on it
        outfile.write("// OUTPUTFORMAT="+self.outputformatcode+"\n")


    def DoOutput_FromResultList(self,outfile,resultlist):
        # output all groups
        self.DoOutput_AllHeader(outfile,len(resultlist))
        for resultgroup in resultlist:
            self.DoOutput_Group(outfile,resultgroup)
        self.DoOutput_AllFooter(outfile,len(resultlist))


    def DoOutput_Group(self,outfile,resultgroup):
        self.DoOutput_GroupHeader(outfile,resultgroup)
        for result in resultgroup:
            self.DoOutput_Result(outfile,resultgroup,result)
        self.DoOutput_GroupFooter(outfile,resultgroup)



    def DoOutput_AllHeader(self,outfile,groupcount):
        #outfile.write("----------------------------------------------------------"+"\n")
        pass

    def DoOutput_AllFooter(self,outfile,groupcount):
        #outfile.write("----------------------------------------------------------"+"\n")
        pass


#---------------------------------------------------------------------------




