#-------------------------------------------------------------------------------
# Name:        process
#-------------------------------------------------------------------------------
#!/usr/bin/env python






#-------------------------------------------------------------------------------
# imports we need
# include top level directory (needed to import from helper below)
import sys
import os
#-------------------------------------------------------------------------------



#-------------------------------------------------------------------------------
# include top level directory (needed to import from helper below)
#curpath = os.path.dirname(os.path.realpath(__file__))
#parpath = os.path.normpath(os.path.join(curpath, "../.."))
#sys.path.append(parpath+"/core")

# import the helper classes
from TWLCHelper import *
#-------------------------------------------------------------------------------






























#---------------------------------------------------------------------------
class TProcess(object):

    def __init__(self):
        # create the TWLCHelper helper
        self.helper = TWLCHelper()

    def __del__(self):
        pass


    def ParseDerivedCommandlineArgs(self):
        pass


    def DoParseCommandline(self,comlineargs):
        # set usage
        self.helper.set_usage("sample usage: %prog [options] arg")
        # commandline options
        # other commandline options
        self.helper.get_parser().add_option("", "--infile", dest="infile", help="input file (full path)")
        self.helper.get_parser().add_option("", "--outfile", dest="outfile", help="output file (full path), or defaults to stdout")
        # derived specific
        self.ParseDerivedCommandlineArgs()
        # ok parse some args from commandline
        self.helper.ParseCommandlineParameters(comlineargs)
        # open filein and fileout files (or stdio)
        self.helper.OpenIO()


    def ParseDerivedCommandlineArgs(self):
        # parse any derived object specific commandline options
        pass


    def RunWithCommandlineOptions(self,comlineargs):
        # parse commandline using helper
        self.DoParseCommandline(comlineargs)
        # extra args?
        extraargs=[]
        # run it
        retv = self.DoWork(self.helper.get_filein(),self.helper.get_fileout(),extraargs)
        return retv


    def DoWork(self,filein,fileout,extraargs):
        # process all lines of file and build into outlines
        linelist=self.helper.ReadLineListFromInput(filein)
        outlines=[]
        for linestr in linelist:
            # convert the linestring to a line dict
            if (self.helper.iscommentline(linestr)) or (linestr==""):
                # comment line just goes to outlines
                outline = {"commentline":linestr}
            else:
                linedict = self.DoProcessLineString(linestr,extraargs)
                outline = self.DoProcessLineDict(linedict,extraargs)
            # add it
            if (outline!=None):
                outlines.append(outline)

        # another place to do work
        outlines = self.DoFinishLines(outlines,extraargs)

        # write them out
        for linedict in outlines:
            self.helper.WriteProcessOutputLine(fileout,linedict)

        # success
        return 0



    def GetTargetDictList(self,targetword):
        # helper function for dealing with targets
        allowedwords = ["label","search","url","linktitle"]
        if (targetword.upper()=="ALL"):
            targetlist=allowedwords
        else:
            words = targetword.split(",")
            # now add and lowercase them, and check for errors
            targetlist = []
            for word in words:
                word = word.lower()
                if (word in allowedwords):
                    targetlist.append(word)
                else:
                    raise Exception("Error in parameter --target: "+word+" is not an allowed field.")
        return targetlist







    # these are the two functions one would overide for derived class

    def DoProcessLineString(self,linestr, extraargs):
        # parse the line into dictionary entries (note that if it is a plaintext line, the True param will create a dictionary with search and label both set to linestr
        linedict = self.helper.DoParseProcessLine(linestr,True)
        return linedict

    def DoProcessLineDict(self,linedict, extraargs):
        # manipulate the linedict in any way one wants
        return linedict

    def DoFinishLines(self, outlines, extraargs):
        # manipulate lines as a whole
        return outlines
#---------------------------------------------------------------------------







































#---------------------------------------------------------------------------
def main(comlineargs=None):
    # make cacegrab object
    processor = TProcess()

    # and ask it to run with commandline options
    return processor.RunWithCommandlineOptions(comlineargs)
#---------------------------------------------------------------------------






#-------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#-------------------------------------------------------------------------------


