#-------------------------------------------------------------------------------
# Name:        preprocess, regex split
#-------------------------------------------------------------------------------
#!/usr/bin/env python






#-------------------------------------------------------------------------------
# imports we need
# include top level directory (needed to import from helper below)
import sys
import os
#-------------------------------------------------------------------------------



#-------------------------------------------------------------------------------
# add parent directory to path
curpath = os.path.dirname(os.path.realpath(__file__))
parpath = os.path.normpath(os.path.join(curpath, ".."))
sys.path.append(parpath)

# import the parent classes
from TProcess import *
#-------------------------------------------------------------------------------


















#---------------------------------------------------------------------------
class TPreProcess_SplitRegex(TProcess):

    def __init__(self):
        # parent init
        super(TPreProcess_SplitRegex, self).__init__()

    def __del__(self):
        pass


    def ParseDerivedCommandlineArgs(self):
        self.helper.get_parser().add_option("", "--regex", dest="regex", help="regex pattern to apply")
        self.helper.get_parser().add_option("", "--label", dest="label", help="the backreference pattern for label component")
        self.helper.get_parser().add_option("", "--search", dest="search", help="the backreference pattern for label component")
        # add match options
        self.helper.Handle_Match_ParseDerivedCommandlineArgs()


    def RunWithCommandlineOptions(self,comlineargs):
        # parse commandline using helper
        self.DoParseCommandline(comlineargs)
        # build extraargs
        extraargs = {}
        extraargs["regex"]=self.helper.get_arg("regex","",True)
        extraargs["label"]=self.helper.get_arg("label","",False)
        extraargs["search"]=self.helper.get_arg("search","ALL",False)
        # lets compile our regex
        extraargs["_compiledregex"]=re.compile(extraargs["regex"],flags=re.IGNORECASE)
        # preprocess match options
        self.helper.Handle_Match_DoCommandlineOptionsProcess(extraargs)
        # run it
        retv = self.DoWork(self.helper.get_filein(),self.helper.get_fileout(),extraargs)
        return retv




    # overridden

    def DoProcessLineDict(self,linedict,extraargs):
        # manipulate the linedict in any way one wants

        # match check? we only continue if we match
        if (not self.helper.DoMatchTest_OnCompiledMatchArg(extraargs,linedict)):
            return linedict;

        label = linedict["label"]

        # ok now match against label
        matchresult = re.match(extraargs["_compiledregex"], label,)
        if (matchresult==None):
            return linedict

        # there is a match, we will grab group matches
        newlabel = matchresult.expand(extraargs["label"])
        newsearch = matchresult.expand(extraargs["search"])

        linedict["label"]=newlabel.strip()
        linedict["search"]=newsearch.strip()

        return linedict
#---------------------------------------------------------------------------















































#---------------------------------------------------------------------------
def main(comlineargs=None):
    # make object
    processor = TPreProcess_SplitRegex()

    # and ask it to run with commandline options
    return processor.RunWithCommandlineOptions(comlineargs)
#---------------------------------------------------------------------------









#-------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#-------------------------------------------------------------------------------


