#-------------------------------------------------------------------------------
# Name:        preprocess, simple split
#-------------------------------------------------------------------------------
#!/usr/bin/env python






#-------------------------------------------------------------------------------
# imports we need
# include top level directory (needed to import from helper below)
import sys
import os
#-------------------------------------------------------------------------------



#-------------------------------------------------------------------------------
# add parent directory to path
curpath = os.path.dirname(os.path.realpath(__file__))
parpath = os.path.normpath(os.path.join(curpath, ".."))
sys.path.append(parpath)

# import the parent classes
from TProcess import *
#-------------------------------------------------------------------------------


















#---------------------------------------------------------------------------
class TPreProcess_SplitSimple(TProcess):

    def __init__(self):
        # parent init
        super(TPreProcess_SplitSimple, self).__init__()

    def __del__(self):
        pass


    def ParseDerivedCommandlineArgs(self):
        self.helper.get_parser().add_option("", "--divider", dest="divider", help="text that separates label from search")
        self.helper.get_parser().add_option("", "--searchboth", action="store_true", dest="searchboth", help="if present this flag says to set the search to full string")
        # add match options
        self.helper.Handle_Match_ParseDerivedCommandlineArgs()


    def RunWithCommandlineOptions(self,comlineargs):
        # parse commandline using helper
        self.DoParseCommandline(comlineargs)
        # build extraargs
        extraargs = {}
        extraargs["divider"]=self.helper.get_arg("divider","",True)
        extraargs["searchboth"]=self.helper.get_arg("searchboth",False,False)
        # preprocess match options
        self.helper.Handle_Match_DoCommandlineOptionsProcess(extraargs)
        # run it
        retv = self.DoWork(self.helper.get_filein(),self.helper.get_fileout(),extraargs)
        return retv




    # overridden

    def DoProcessLineDict(self,linedict,extraargs):
        # manipulate the linedict in any way one wants

        # match check? we only continue if we match
        if (not self.helper.DoMatchTest_OnCompiledMatchArg(extraargs,linedict)):
            return linedict;

        # ok now what we do is take the label part and break it and replace the search part
        label = linedict["label"]
        divider = extraargs["divider"]

        if (label.find(divider)==-1):
            return linedict
        splits = label.split(divider,1)
        if (len(splits)!=2):
            return linedict

        # reassign split
        label=splits[0]
        search=splits[1]
        linedict["label"]=label.strip()

        if (extraargs["searchboth"]):
            linedict["search"]=linedict["label"]+" "+search.strip()
        else:
            linedict["search"]=search.strip()

        return linedict
#---------------------------------------------------------------------------















































#---------------------------------------------------------------------------
def main(comlineargs=None):
    # make object
    processor = TPreProcess_SplitSimple()

    # and ask it to run with commandline options
    return processor.RunWithCommandlineOptions(comlineargs)
#---------------------------------------------------------------------------









#-------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#-------------------------------------------------------------------------------


